View Issue Details

IDProjectCategoryView StatusLast Update
0000198Far Manager 1.7xMacropublic2008-07-03 14:32
ReportersdindikovAssigned Tovskirdin 
PrioritynormalSeverityminorReproducibilityalways
Status closedResolutionno change required 
Product Version1.71 
Target VersionFixed in Version1.71 
Summary0000198: проблема с прорисовкой сообщения при работе с макросом.
DescriptionFAR2104 без плагинов кроме тестового (в аттаче)

выключаем макросы

вызваем тестовый плагин
жмем ESC после вывода плагином сообщения
сообщение сразу пропадает
происходит задержка в 5сек

теперь применяем макрос

[HKEY_CURRENT_USER\Software\Far\KeyMacros\Dialog\Esc]
"Sequence"="Esc"
"DisableOutput"=dword:00000001


вызваем тестовый плагин
жмем ESC после вывода плагином сообщения
сообщение не пропадает
происходит задержка в 5сек
сообщение исчезает

Ожидаемое поведение - одинаковое в обоих случаях.

Проблема в восстановление экрана FAR'a в разное время?

ps. реальный пример произошел при работе плагина Advanced Compare (версии AS alfa19)
когда сравниваем одинаковые каталоги.

2Skirda: Незнаю точно проблема к макро относится или нет :)
TagsNo tags attached.
Build0

Activities

2006-06-04 20:55

 

test_plg.rar (1,865 bytes)

samlyukov

2006-06-04 23:41

reporter   bugnote:0000204

Last edited: 2006-06-04 23:42

сказано в писании:
=============================================================
int WINAPI Message(
  int PluginNumber,
  DWORD Flags,
  const char *HelpTopic,
  const char * const *Items,
  int ItemsNumber,
  int ButtonsNumber
);

Если ButtonsNumber не равен 0, то экран восстанавливает сам FAR.
================================================================

Я так и делаю - не перерисовываю экран, т.к. это должен делать Фар,
но он сразу переходит к выполнению макры.

samlyukov

2006-08-08 01:14

reporter   bugnote:0000261

сюда же(на мой взгляд схожие симптомы)
плагины permanency 1.5.0.0, AdvCompare 1.71.24

Если есть файлы или папки, помеченные при помощи permanency, то плагин AdvCompare не помечает различающиеся файлы,
не важно, где находится помеченный перманенси файл.

Наблюдается данное поведение только после того, как в ходе сравнения появилось какое-нибудь сообщение об ошибке или предупреждение от AdvCompare. Внешне выглядит так, словно AdvCompare "забыл" о коде по перерисовке панели.

vskirdin

2006-12-14 06:11

administrator   bugnote:0000357

тут дело в том, что
1. DisableOutput=1, т.е. прорисовка залочена
2. Press Esc. Макрос? Ага! Вернем диалоговой процедуре. Диалог закрылся (но т.к. стоит лочка, прорисовать не можем)
3. Вернули управление плагину.
4. Когда плагин вернул управление ФАРу... то закончилась последовательность макросов (завершающий этап).

vskirdin

2006-12-14 07:03

administrator   bugnote:0000358

тыкс...
Проверяем - http://farmanager.com/farbugs/mantis198.1.rar
тока проверяй все, что касается макросов, т.к. немного переделал финализе исполнятора макросов.

sdindikov

2006-12-14 18:29

developer   bugnote:0000361

по тестам Fixed!

и вроде побочных эффектов не появилось...

vskirdin

2006-12-15 06:29

administrator   bugnote:0000366

Не нравится что-то мне эта шняга...

Есть у меня макрос "F11 ? 1 !".
Здесь
'?' - хоткей для "cdHelps"
'1' - Context-dependent help
'!' - Previous query

Если раньше в консоли ничего не появлялось, а просто тупо появлялся гуевый хелп.
То сейчас мелькает меню - открывается и закрывается.

В общем считаю неудачным этот патч. Бум думать. Но здесь мне нужна статистика по поведению других визуальных объектов (а не только менюх), ибо...
1. либо делать только для VMenu затычку
2. либо возвращаться обратно
3. либо думать :-)

DiRTy_GaRRy

2006-12-15 08:29

developer   bugnote:0000372

Та же самая фигня в http://farmanager.com/farbugs/mantis254.2.rar. При работе макроса "F11 E Enter" (показ текстового контекстного меню через EMenu) теперь сначала мелькает корневая менюшка, а потом только показывается само контекстое меню.

vskirdin

2006-12-15 08:41

administrator   bugnote:0000376

Следующий тест:
http://farmanager.com/farbugs/mantis198.2.rar

DiRTy_GaRRy

2006-12-15 09:38

developer   bugnote:0000377

Для EMenu теперь всё работает нормально, т.е. по старому.

vskirdin

2006-12-15 09:47

administrator   bugnote:0000378

после 2157

DrKnS

2006-12-16 19:46

administrator   bugnote:0000380

однако фигня теперь получается:

тестовый плугин (в аттаче) в OpenPlugin постит KEY_ENTER.
1. Вешаем на него макру, допустим на F2. Пишем в комстроку macro:post CtrlO и жмем F2 - тишина... CtrlO наступит только после эникея.
2. Пишем в комстроке или юзерменю macro:post F11 <хоткей_тестового_плугина>. Наблюдаем симпатичное мерцание плугинменю и неработоспособный фар (что постит плагин в этом случае неважно).

2006-12-16 19:46

 

postkeysequence.rar (1,130 bytes)

vskirdin

2006-12-18 07:32

administrator   bugnote:0000381

Мля...
Пятница - день тяжелый :-)
http://farmanager.com/farbugs/mantis198.3.rar

DrKnS

2006-12-18 08:18

administrator   bugnote:0000382

С этим ок, но есть ещё :-)

было:
macro:post F2 Esc - перерисовки нет.
macro:post $mmode 1 F2 Esc - перерисовка есть.
macro:post $mmode 1 $mmode 1 F2 Esc - опять нет.

теперь есть во всех случаях...

vskirdin

2006-12-18 08:46

administrator   bugnote:0000383

Ндя... все веселее и веселее.
В обчем я откатываю все взад и объявляю... Инвалидом.
Изначальную заяву багом считать трудно, т.к. это есть особунность реализации движка. И, в случае с указанным изначальным тестовым плагинов, получается все честно - т.е. пока управление не будет передано ФАРу... перерисовки не будет.
Выход здесь прост - после вызова Message передать ФАРу рульку (например, послать ACTL_COMMIT)

Issue History

Date Modified Username Field Change
2006-06-04 20:55 sdindikov New Issue
2006-06-04 20:55 sdindikov Status new => assigned
2006-06-04 20:55 sdindikov Assigned To => vskirdin
2006-06-04 20:55 sdindikov File Added: test_plg.rar
2006-06-04 23:41 samlyukov Note Added: 0000204
2006-06-04 23:42 samlyukov Note Edited: 0000204
2006-08-08 01:14 samlyukov Note Added: 0000261
2006-12-14 06:11 vskirdin Note Added: 0000357
2006-12-14 07:03 vskirdin Note Added: 0000358
2006-12-14 18:29 sdindikov Note Added: 0000361
2006-12-14 18:30 sdindikov Status assigned => resolved
2006-12-14 18:30 sdindikov Resolution open => fixed
2006-12-15 06:29 vskirdin Note Added: 0000366
2006-12-15 06:29 vskirdin Status resolved => assigned
2006-12-15 08:29 DiRTy_GaRRy Note Added: 0000372
2006-12-15 08:41 vskirdin Note Added: 0000376
2006-12-15 09:38 DiRTy_GaRRy Note Added: 0000377
2006-12-15 09:47 vskirdin Status assigned => resolved
2006-12-15 09:47 vskirdin Fixed in Version => 1.71
2006-12-15 09:47 vskirdin Note Added: 0000378
2006-12-16 19:46 DrKnS Status resolved => feedback
2006-12-16 19:46 DrKnS Resolution fixed => reopened
2006-12-16 19:46 DrKnS Note Added: 0000380
2006-12-16 19:46 DrKnS File Added: postkeysequence.rar
2006-12-18 07:32 vskirdin Note Added: 0000381
2006-12-18 08:18 DrKnS Note Added: 0000382
2006-12-18 08:46 vskirdin Note Added: 0000383
2008-07-03 14:32 alexy Build => 0
2008-07-03 14:32 alexy Status feedback => resolved
2008-07-03 14:32 alexy Resolution reopened => no change required
2008-07-03 14:32 alexy Status resolved => closed